svn commit: r440385 - in head/security/tor-devel: . files

Sunpoet Po-Chuan Hsieh sunpoet at FreeBSD.org
Sun May 7 21:27:40 UTC 2017


Author: sunpoet
Date: Sun May  7 21:27:38 2017
New Revision: 440385
URL: https://svnweb.freebsd.org/changeset/ports/440385

Log:
  Add tor_instances (from security/tor)
  
  - Add MANPAGES option (split from DOCS option)
  - Remove TRANSPARENT option
  - Bump PORTREVISION for package change
  - While I'm here, update BROKEN: use lowercase for leading character
  
  PR:		219116
  Submitted by:	Yuri Victorovich <yuri at rawbw.com> (maintainer)

Modified:
  head/security/tor-devel/Makefile
  head/security/tor-devel/files/pkg-message.in
  head/security/tor-devel/files/tor.in
  head/security/tor-devel/pkg-plist

Modified: head/security/tor-devel/Makefile
==============================================================================
--- head/security/tor-devel/Makefile	Sun May  7 21:27:33 2017	(r440384)
+++ head/security/tor-devel/Makefile	Sun May  7 21:27:38 2017	(r440385)
@@ -2,7 +2,8 @@
 # $FreeBSD$
 
 PORTNAME=	tor
-DISTVERSION=	0.3.0.6
+PORTVERSION=	0.3.0.6
+PORTREVISION=	1
 CATEGORIES=	security net ipv6
 MASTER_SITES=	TOR
 PKGNAMESUFFIX=	-devel
@@ -13,9 +14,9 @@ COMMENT=	Anonymizing overlay network for
 LICENSE=	BSD3CLAUSE
 LICENSE_FILE=	${WRKSRC}/LICENSE
 
-BROKEN_mips64=	Does not build: error: Need a uint128_t implementation!
-BROKEN_powerpc64=	Does not build: error: Need a uint128_t implementation!
-BROKEN_sparc64=	Does not build: error: Need a uint128_t implementation!
+BROKEN_mips64=	does not build: error: Need a uint128_t implementation!
+BROKEN_powerpc64=	does not build: error: Need a uint128_t implementation!
+BROKEN_sparc64=	does not build: error: Need a uint128_t implementation!
 
 USES=		cpe gmake
 CPE_VENDOR=	torproject
@@ -27,18 +28,19 @@ CONFIGURE_ENV=	TOR_CPPFLAGS_libevent="-I
 		TOR_LDFLAGS_libevent="-L${LOCALBASE}/lib/" \
 		TOR_LIBEVENT_LIBS="${TOR_LIBEVENT_LIBS}"
 
-OPTIONS_DEFINE=	MANPAGES STATIC_TOR TCMALLOC TOR2WEB TRANSPARENT
+OPTIONS_DEFINE=	MANPAGES DOCS STATIC_TOR TCMALLOC TOR2WEB
 OPTIONS_SUB=	yes
 
 STATIC_TOR_DESC=	Build a static tor
 TCMALLOC_DESC=		Use the tcmalloc memory allocation library
 TOR2WEB_DESC=		(EXPERT OPTION) Faster but non-anonymous hidden services
-TRANSPARENT_DESC=	Transparent proxy support
 
-OPTIONS_DEFAULT=	MANPAGES TRANSPARENT
+OPTIONS_DEFAULT=	MANPAGES
 
 USE_RC_SUBR=	tor
 SUB_FILES=	pkg-message
+SUB_LIST=	USER="${USERS}" GROUP="${GROUPS}"
+PLIST_SUB=	USER="${USERS}" GROUP="${GROUPS}"
 
 GROUPS=		_tor
 USERS=		_tor
@@ -48,8 +50,8 @@ CONFLICTS=	tor-[0-9]*
 STATIC_TOR_USES=	ssl:build
 STATIC_TOR_USES_OFF=	ssl
 
-MANPAGES_BUILD_DEPENDS=	asciidoc:textproc/asciidoc
-MANPAGES_CONFIGURE_OFF=	--disable-asciidoc
+DOCS_BUILD_DEPENDS=	asciidoc:textproc/asciidoc
+DOCS_CONFIGURE_OFF=	--disable-asciidoc
 
 .include <bsd.port.options.mk>
 
@@ -84,12 +86,6 @@ LIB_DEPENDS+=		libtcmalloc.so:devel/goog
 CONFIGURE_ARGS+=	--enable-tor2web-mode
 .endif
 
-.if ${PORT_OPTIONS:MTRANSPARENT}
-CONFIGURE_ARGS+=	--enable-transparent
-.else
-CONFIGURE_ARGS+=	--disable-transparent
-.endif
-
 pre-everything::
 .if ${PORT_OPTIONS:MTOR2WEB}
 	@${ECHO_MSG}
@@ -116,12 +112,8 @@ post-patch-STATIC_TOR-on:
 	@${REINPLACE_CMD} -e "s at -ltcmalloc@${LOCALBASE}/lib/libtcmalloc.a@" \
 		${WRKSRC}/configure
 
-post-configure:
-	@${REINPLACE_CMD} -e '\|^nodist_man1_MANS =|s|$$|$$(install_mans:=.1)|' \
-		${WRKSRC}/Makefile
-
 post-install:
-	@${MKDIR} ${STAGEDIR}/var/log/tor ${STAGEDIR}/var/run/tor
+	@${MKDIR} ${STAGEDIR}/var/log/tor ${STAGEDIR}/var/run/tor ${STAGEDIR}/var/db/tor
 
 .if ! ${PORT_OPTIONS:MTOR2WEB}
 check regression-test test: build

Modified: head/security/tor-devel/files/pkg-message.in
==============================================================================
--- head/security/tor-devel/files/pkg-message.in	Sun May  7 21:27:33 2017	(r440384)
+++ head/security/tor-devel/files/pkg-message.in	Sun May  7 21:27:38 2017	(r440385)
@@ -11,4 +11,12 @@ exploits sequential IP IDs by setting:
 sysctl net.inet.ip.random_id=1
 
 (see sysctl.conf(5)).
+
+In order to run additional, independent instances of tor on the same machine
+set tor_instances="inst1 inst2 ..." in your /etc/rc.conf, and create the
+corresponding additional configuration files %%PREFIX%%/etc/tor/torrc at inst1, ...
+
+Alternatively, you can use the extended instance definition to specify all
+instance parameteres explicitly:
+inst_name{:inst_conf:inst_user:inst_group:inst_pidfile:inst_data_dir}
 ================================================================================

Modified: head/security/tor-devel/files/tor.in
==============================================================================
--- head/security/tor-devel/files/tor.in	Sun May  7 21:27:33 2017	(r440384)
+++ head/security/tor-devel/files/tor.in	Sun May  7 21:27:38 2017	(r440385)
@@ -11,24 +11,99 @@
 # they are command line options.
 #
 # tor_enable (bool):	Set it to "YES" to enable tor. Default: NO
+# tor_instances (str):	List of instances. Default: ""
 # tor_conf (str):	Points to your torrc file.
 #			Default: %%PREFIX%%/etc/tor/torrc
-# tor_user (str):	Tor daemon user. Default: _tor
+# tor_user (str):	Tor daemon user. Default: %%USER%%
+# tor_group (str):	Tor group. Default: %%GROUP%%
+# tor_pidfile (str):	Tor pid file.  Default: /var/run/tor/tor.pid
 # tor_datadir (str):	Tor datadir.  Default: /var/db/tor
+# tor_disable_default_instance (str):	Doesn't run the default instance.
+#			Only valid when tor_instances is used.
+#			Default: NO
+#
+# The instance definition that tor_instances expects:
+# inst_name{:inst_conf:inst_user:inst_group:inst_pidfile:inst_data_dir}
 #
 
 . /etc/rc.subr
 
 name="tor"
 rcvar=tor_enable
+exit_code=0
 
 load_rc_config ${name}
 
 : ${tor_enable="NO"}
+: ${tor_instances=""}
 : ${tor_conf="%%PREFIX%%/etc/tor/torrc"}
-: ${tor_user="_tor"}
+: ${tor_user="%%USER%%"}
+: ${tor_group="%%GROUP%%"}
 : ${tor_pidfile="/var/run/tor/tor.pid"}
 : ${tor_datadir="/var/db/tor"}
+: ${tor_disable_default_instance="NO"}
+
+instance=${slave_instance}
+if [ -n "${instance}" ]; then
+  inst_def=${instance}
+  inst_name=${inst_def%%:*}
+  [ "${inst_name}" != "main" ] || err 1 "${name} instance can't be named 'main'"
+  inst_def=${inst_def#$inst_name}
+  if [ -n "$inst_def" ]; then
+    # extended instance: parameters are set explicitly
+    inst_def=${inst_def#:}
+    tor_conf=${inst_def%%:*}
+    inst_def=${inst_def#$tor_conf:}
+    tor_user=${inst_def%%:*}
+    inst_def=${inst_def#$tor_user:}
+    tor_group=${inst_def%%:*}
+    inst_def=${inst_def#$tor_group:}
+    tor_pidfile=${inst_def%%:*}
+    tor_datadir=${inst_def#$tor_pidfile:}
+    if [ -z "${tor_conf}" -o -z "${tor_user}" -o -z "${tor_group}" -o -z "${tor_pidfile}" -o -z "${tor_datadir}" ]; then
+      warn "invalid tor instance ${inst_name} settings: ${instance}"
+      exit 1
+    fi
+  else
+    # regular instance: default parameters are used
+    tor_conf=${tor_conf}@${inst_name}
+    tor_pidfile=${tor_pidfile}@${inst_name}
+    tor_datadir=${tor_datadir}/instance@${inst_name}
+  fi
+  if ! [ -r ${tor_conf} ]; then
+    warn "tor instance ${inst_name} config file ${tor_conf} doesn't exist or isn't readable"
+    warn "you can copy the sample config %%PREFIX%%/etc/tor/torrc.sample and modify it"
+    exit 1
+  fi
+  if ! [ -d ${tor_datadir} ]; then
+    mkdir -p ${tor_datadir} &&
+    chown ${tor_user}:${tor_group} ${tor_datadir} &&
+    chmod 0700 ${tor_datadir} &&
+    echo "${name}: created the instance data directory ${tor_datadir}"
+  fi
+fi
+
+if [ -z "${instance}" -a -n "${tor_instances}" ]; then
+  inst_only="$2"
+  inst_done=0
+  for i in ${tor_instances}; do
+    inst_name=${i%%:*}
+    if [ -z "${inst_only}" -o "${inst_name}" = "${inst_only}" ]; then
+      echo -n "${name} instance ${inst_name}: "
+      if ! slave_instance=${i} %%PREFIX%%/etc/rc.d/tor "$1"; then
+        exit_code=1
+      fi
+      inst_done=$((inst_done+1))
+    fi
+  done
+  if [ -z "${inst_only}" -o "${inst_only}" = "main" ]; then
+    checkyesno tor_disable_default_instance && return $exit_code
+    echo -n "${name} main instance: "
+  elif [ -n "${inst_only}" ]; then
+    [ $inst_done -gt 0 ] || err 1 "${name} instance '$inst_only' isn't defined"
+    return  $exit_code
+  fi
+fi
 
 required_files=${tor_conf}
 required_dirs=${tor_datadir}
@@ -37,5 +112,8 @@ command="%%PREFIX%%/bin/${name}"
 command_args="-f ${tor_conf} --PidFile ${tor_pidfile} --RunAsDaemon 1 --DataDirectory ${tor_datadir}"
 extra_commands="reload"
 
-run_rc_command "$1"
+if ! run_rc_command "$1"; then
+  exit_code=1
+fi
 
+return $exit_code

Modified: head/security/tor-devel/pkg-plist
==============================================================================
--- head/security/tor-devel/pkg-plist	Sun May  7 21:27:33 2017	(r440384)
+++ head/security/tor-devel/pkg-plist	Sun May  7 21:27:38 2017	(r440385)
@@ -7,11 +7,12 @@ bin/torify
 %%MANPAGES%%man/man1/tor-resolve.1.gz
 %%MANPAGES%%man/man1/tor.1.gz
 %%MANPAGES%%man/man1/torify.1.gz
-%%MANPAGES%%%%PORTDOCS%%%%DOCSDIR%%/tor-gencert.html
-%%MANPAGES%%%%PORTDOCS%%%%DOCSDIR%%/tor-resolve.html
-%%MANPAGES%%%%PORTDOCS%%%%DOCSDIR%%/tor.html
-%%MANPAGES%%%%PORTDOCS%%%%DOCSDIR%%/torify.html
+%%PORTDOCS%%%%DOCSDIR%%/tor-gencert.html
+%%PORTDOCS%%%%DOCSDIR%%/tor-resolve.html
+%%PORTDOCS%%%%DOCSDIR%%/tor.html
+%%PORTDOCS%%%%DOCSDIR%%/torify.html
 %%DATADIR%%/geoip
 %%DATADIR%%/geoip6
- at dir(_tor,_tor,750) /var/run/tor
- at dir(_tor,_tor,750) /var/log/tor
+ at dir(%%USER%%,%%GROUP%%,700) /var/run/tor
+ at dir(%%USER%%,%%GROUP%%,700) /var/log/tor
+ at dir(%%USER%%,%%GROUP%%,700) /var/db/tor


More information about the svn-ports-all mailing list